(defproject wanijo "0.3.0"
  :description "Graph Database via UI"
  :url "https://gitea.heevyis.ninja/josha/wanijo"
  :min-lein-version "2.9.0"
  :license {:name "GPL-3.0"
            :url "https://opensource.org/licenses/GPL-3.0"}

  :dependencies [;;clojure core
                 [org.clojure/clojure "1.10.1"]
                 [nrepl "0.8.3"]

                 ;; static site
                 [compojure "1.6.2"]
                 [ring/ring-defaults "0.3.2"]
                 [ring/ring-jetty-adapter "1.8.2"
                  :exclusions [ring/ring-core
                               ring/ring-codec
                               commons-io
                               commons-codec]]
                 [ring/ring-json "0.5.0"]
                 [hiccup "1.0.5"]
                 [joshavg/formulare "0.6.0"]

                 ;; compojure uses old transitive dependencies of ring
                 ;; specifiy them here explicitly so newer versions
                 ;; will be used
                 [ring/ring-core "1.8.2"]
                 [ring/ring-codec "1.1.2"]

                 ;; neo4j
                 [gorillalabs/neo4j-clj "4.1.0"]
                 [org.neo4j.test/neo4j-harness "4.2.1"
                  :exclusions
                  [com.fasterxml.jackson.core/jackson-core
                   commons-codec]]

                 ;; additional server side libs
                 [buddy/buddy-hashers "1.7.0"
                  :exclusions
                  [com.fasterxml.jackson.dataformat/jackson-dataformat-smile
                   com.fasterxml.jackson.dataformat/jackson-dataformat-cbor
                   com.fasterxml.jackson.core/jackson-core
                   org.bouncycastle/bcprov-jdk15on
                   org.bouncycastle/bcpkix-jdk15on
                   commons-codec
                   cheshire
                   tigris]]
                 [clj-time "0.15.2"]
                 [markdown-clj "1.10.5"]
                 [dorothy "0.0.7"]]

  :profiles {:dev {:plugins [;; web stuff
                             [lein-less "1.7.5"]

                             ;; code quality
                             [lein-ancient "LATEST"]
                             [jonase/eastwood "LATEST"]
                             [lein-bikeshed "LATEST"]
                             [lein-cloverage "LATEST"]
                             [lein-kibit "LATEST"]]}
             :uberjar {:aot :all
                       :main wanijo.main}}

  :neo4j {:path "neo4j"}
  :repl-options {:init-ns wanijo.infrastructure.repl}
  :less {:source-paths ["resources/app/stylesheets"]
         :target-path "resources/public/css"}
  :aliases {"uberjar" ["do" ["less" "once"] "uberjar"]}
  :hiera {:cluster-depth 2}
  :eastwood {:namespaces [:source-paths]})
