(ns wanijo.instance.view.view
  (:require [hiccup.core :refer [h]]))

(defn tags-for-search [{tags :tags}]
  [:span.tags-for-search
   (reduce #(str %1 ":" (h (:name %2))) "" tags)])

(defn req-attrs-headings [{:keys [req-attrs]}]
  (map (fn [attr] [:th (h (:name attr))])
       req-attrs))

(defn req-attrs-cells [{:keys [req-attrs]}
                       {:keys [properties]}]
  (map (fn [{attr-uuid :uuid}]
         [:td (->> properties
                   (filter #(= attr-uuid
                               (-> % :attribute :uuid)))
                   first
                   :value
                   h)])
       req-attrs))
